/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "backend_interface.h"

#include <string.h>
#ifdef G_OS_UNIX
#  include <gio/gunixfdlist.h>
#endif

typedef struct
{
  GDBusArgInfo parent_struct;
  gboolean use_gvariant;
} _ExtendedGDBusArgInfo;

typedef struct
{
  GDBusMethodInfo parent_struct;
  const gchar *signal_name;
  gboolean pass_fdlist;
} _ExtendedGDBusMethodInfo;

typedef struct
{
  GDBusSignalInfo parent_struct;
  const gchar *signal_name;
} _ExtendedGDBusSignalInfo;

typedef struct
{
  GDBusPropertyInfo parent_struct;
  const gchar *hyphen_name;
  guint use_gvariant : 1;
  guint emits_changed_signal : 1;
} _ExtendedGDBusPropertyInfo;

typedef struct
{
  GDBusInterfaceInfo parent_struct;
  const gchar *hyphen_name;
} _ExtendedGDBusInterfaceInfo;

typedef struct
{
  const _ExtendedGDBusPropertyInfo *info;
  guint prop_id;
  GValue orig_value; /* the value before the change */
} ChangedProperty;

static void
_changed_property_free (ChangedProperty *data)
{
  g_value_unset (&data->orig_value);
  g_free (data);
}

static gboolean
_g_strv_equal0 (gchar **a, gchar **b)
{
  gboolean ret = FALSE;
  guint n;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  if (g_strv_length (a) != g_strv_length (b))
    goto out;
  for (n = 0; a[n] != NULL; n++)
    if (g_strcmp0 (a[n], b[n]) != 0)
      goto out;
  ret = TRUE;
out:
  return ret;
}

static gboolean
_g_variant_equal0 (GVariant *a, GVariant *b)
{
  gboolean ret = FALSE;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  ret = g_variant_equal (a, b);
out:
  return ret;
}

G_GNUC_UNUSED static gboolean
_g_value_equal (const GValue *a, const GValue *b)
{
  gboolean ret = FALSE;
  g_assert (G_VALUE_TYPE (a) == G_VALUE_TYPE (b));
  switch (G_VALUE_TYPE (a))
    {
      case G_TYPE_BOOLEAN:
        ret = (g_value_get_boolean (a) == g_value_get_boolean (b));
        break;
      case G_TYPE_UCHAR:
        ret = (g_value_get_uchar (a) == g_value_get_uchar (b));
        break;
      case G_TYPE_INT:
        ret = (g_value_get_int (a) == g_value_get_int (b));
        break;
      case G_TYPE_UINT:
        ret = (g_value_get_uint (a) == g_value_get_uint (b));
        break;
      case G_TYPE_INT64:
        ret = (g_value_get_int64 (a) == g_value_get_int64 (b));
        break;
      case G_TYPE_UINT64:
        ret = (g_value_get_uint64 (a) == g_value_get_uint64 (b));
        break;
      case G_TYPE_DOUBLE:
        {
          /* Avoid -Wfloat-equal warnings by doing a direct bit compare */
          gdouble da = g_value_get_double (a);
          gdouble db = g_value_get_double (b);
          ret = memcmp (&da, &db, sizeof (gdouble)) == 0;
        }
        break;
      case G_TYPE_STRING:
        ret = (g_strcmp0 (g_value_get_string (a), g_value_get_string (b)) == 0);
        break;
      case G_TYPE_VARIANT:
        ret = _g_variant_equal0 (g_value_get_variant (a), g_value_get_variant (b));
        break;
      default:
        if (G_VALUE_TYPE (a) == G_TYPE_STRV)
          ret = _g_strv_equal0 (g_value_get_boxed (a), g_value_get_boxed (b));
        else
          g_critical ("_g_value_equal() does not handle type %s", g_type_name (G_VALUE_TYPE (a)));
        break;
    }
  return ret;
}

/* ------------------------------------------------------------------------
 * Code for interface org.openprinting.PrintBackend
 * ------------------------------------------------------------------------
 */

/**
 * SECTION:PrintBackend
 * @title: PrintBackend
 * @short_description: Generated C code for the org.openprinting.PrintBackend D-Bus interface
 *
 * This section contains code for working with the <link linkend="gdbus-interface-org-openprinting-PrintBackend.top_of_page">org.openprinting.PrintBackend</link> D-Bus interface in C.
 */

/* ---- Introspection data for org.openprinting.PrintBackend ---- */

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_backend_name_OUT_ARG_backend_name =
{
  {
    -1,
    (gchar *) "backend_name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_backend_name_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_get_backend_name_OUT_ARG_backend_name.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_get_backend_name =
{
  {
    -1,
    (gchar *) "GetBackendName",
    NULL,
    (GDBusArgInfo **) &_print_backend_method_info_get_backend_name_OUT_ARG_pointers,
    NULL
  },
  "handle-get-backend-name",
  FALSE
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_activate_backend =
{
  {
    -1,
    (gchar *) "ActivateBackend",
    NULL,
    NULL,
    NULL
  },
  "handle-activate-backend",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_default_printer_OUT_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_default_printer_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_get_default_printer_OUT_ARG_printer_id.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_get_default_printer =
{
  {
    -1,
    (gchar *) "getDefaultPrinter",
    NULL,
    (GDBusArgInfo **) &_print_backend_method_info_get_default_printer_OUT_ARG_pointers,
    NULL
  },
  "handle-get-default-printer",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_printer_state_IN_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_printer_state_IN_ARG_pointers[] =
{
  &_print_backend_method_info_get_printer_state_IN_ARG_printer_id.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_printer_state_OUT_ARG_state =
{
  {
    -1,
    (gchar *) "state",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_printer_state_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_get_printer_state_OUT_ARG_state.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_get_printer_state =
{
  {
    -1,
    (gchar *) "getPrinterState",
    (GDBusArgInfo **) &_print_backend_method_info_get_printer_state_IN_ARG_pointers,
    (GDBusArgInfo **) &_print_backend_method_info_get_printer_state_OUT_ARG_pointers,
    NULL
  },
  "handle-get-printer-state",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_is_accepting_jobs_IN_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_is_accepting_jobs_IN_ARG_pointers[] =
{
  &_print_backend_method_info_is_accepting_jobs_IN_ARG_printer_id.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_is_accepting_jobs_OUT_ARG_is_accepting =
{
  {
    -1,
    (gchar *) "is_accepting",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_is_accepting_jobs_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_is_accepting_jobs_OUT_ARG_is_accepting.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_is_accepting_jobs =
{
  {
    -1,
    (gchar *) "isAcceptingJobs",
    (GDBusArgInfo **) &_print_backend_method_info_is_accepting_jobs_IN_ARG_pointers,
    (GDBusArgInfo **) &_print_backend_method_info_is_accepting_jobs_OUT_ARG_pointers,
    NULL
  },
  "handle-is-accepting-jobs",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_all_options_IN_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_all_options_IN_ARG_pointers[] =
{
  &_print_backend_method_info_get_all_options_IN_ARG_printer_id.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_all_options_OUT_ARG_num_options =
{
  {
    -1,
    (gchar *) "num_options",
    (gchar *) "i",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_all_options_OUT_ARG_options =
{
  {
    -1,
    (gchar *) "options",
    (gchar *) "a(ssia(s))",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_all_options_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_get_all_options_OUT_ARG_num_options.parent_struct,
  &_print_backend_method_info_get_all_options_OUT_ARG_options.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_get_all_options =
{
  {
    -1,
    (gchar *) "GetAllOptions",
    (GDBusArgInfo **) &_print_backend_method_info_get_all_options_IN_ARG_pointers,
    (GDBusArgInfo **) &_print_backend_method_info_get_all_options_OUT_ARG_pointers,
    NULL
  },
  "handle-get-all-options",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_active_jobs_count_IN_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_active_jobs_count_IN_ARG_pointers[] =
{
  &_print_backend_method_info_get_active_jobs_count_IN_ARG_printer_id.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_active_jobs_count_OUT_ARG_job_count =
{
  {
    -1,
    (gchar *) "job_count",
    (gchar *) "i",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_active_jobs_count_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_get_active_jobs_count_OUT_ARG_job_count.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_get_active_jobs_count =
{
  {
    -1,
    (gchar *) "getActiveJobsCount",
    (GDBusArgInfo **) &_print_backend_method_info_get_active_jobs_count_IN_ARG_pointers,
    (GDBusArgInfo **) &_print_backend_method_info_get_active_jobs_count_OUT_ARG_pointers,
    NULL
  },
  "handle-get-active-jobs-count",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_all_jobs_IN_ARG_active_only =
{
  {
    -1,
    (gchar *) "active_only",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_all_jobs_IN_ARG_pointers[] =
{
  &_print_backend_method_info_get_all_jobs_IN_ARG_active_only.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_all_jobs_OUT_ARG_num_jobs =
{
  {
    -1,
    (gchar *) "num_jobs",
    (gchar *) "i",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_get_all_jobs_OUT_ARG_jobs =
{
  {
    -1,
    (gchar *) "jobs",
    (gchar *) "a(ssssssi)",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_get_all_jobs_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_get_all_jobs_OUT_ARG_num_jobs.parent_struct,
  &_print_backend_method_info_get_all_jobs_OUT_ARG_jobs.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_get_all_jobs =
{
  {
    -1,
    (gchar *) "getAllJobs",
    (GDBusArgInfo **) &_print_backend_method_info_get_all_jobs_IN_ARG_pointers,
    (GDBusArgInfo **) &_print_backend_method_info_get_all_jobs_OUT_ARG_pointers,
    NULL
  },
  "handle-get-all-jobs",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_cancel_job_IN_ARG_job_id =
{
  {
    -1,
    (gchar *) "job_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_cancel_job_IN_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_cancel_job_IN_ARG_pointers[] =
{
  &_print_backend_method_info_cancel_job_IN_ARG_job_id.parent_struct,
  &_print_backend_method_info_cancel_job_IN_ARG_printer_id.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_cancel_job_OUT_ARG_status =
{
  {
    -1,
    (gchar *) "status",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_cancel_job_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_cancel_job_OUT_ARG_status.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_cancel_job =
{
  {
    -1,
    (gchar *) "cancelJob",
    (GDBusArgInfo **) &_print_backend_method_info_cancel_job_IN_ARG_pointers,
    (GDBusArgInfo **) &_print_backend_method_info_cancel_job_OUT_ARG_pointers,
    NULL
  },
  "handle-cancel-job",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_print_file_IN_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_print_file_IN_ARG_file_path_name =
{
  {
    -1,
    (gchar *) "file_path_name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_print_file_IN_ARG_num_settings =
{
  {
    -1,
    (gchar *) "num_settings",
    (gchar *) "i",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_print_file_IN_ARG_settings =
{
  {
    -1,
    (gchar *) "settings",
    (gchar *) "a(ss)",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_print_file_IN_ARG_final_file_path =
{
  {
    -1,
    (gchar *) "final_file_path",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_print_file_IN_ARG_pointers[] =
{
  &_print_backend_method_info_print_file_IN_ARG_printer_id.parent_struct,
  &_print_backend_method_info_print_file_IN_ARG_file_path_name.parent_struct,
  &_print_backend_method_info_print_file_IN_ARG_num_settings.parent_struct,
  &_print_backend_method_info_print_file_IN_ARG_settings.parent_struct,
  &_print_backend_method_info_print_file_IN_ARG_final_file_path.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_print_file_OUT_ARG_jobid =
{
  {
    -1,
    (gchar *) "jobid",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_print_file_OUT_ARG_pointers[] =
{
  &_print_backend_method_info_print_file_OUT_ARG_jobid.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_print_file =
{
  {
    -1,
    (gchar *) "printFile",
    (GDBusArgInfo **) &_print_backend_method_info_print_file_IN_ARG_pointers,
    (GDBusArgInfo **) &_print_backend_method_info_print_file_OUT_ARG_pointers,
    NULL
  },
  "handle-print-file",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_replace_IN_ARG_previous_dialog_id =
{
  {
    -1,
    (gchar *) "previous_dialog_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_replace_IN_ARG_pointers[] =
{
  &_print_backend_method_info_replace_IN_ARG_previous_dialog_id.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_replace =
{
  {
    -1,
    (gchar *) "replace",
    (GDBusArgInfo **) &_print_backend_method_info_replace_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-replace",
  FALSE
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_keep_alive =
{
  {
    -1,
    (gchar *) "keepAlive",
    NULL,
    NULL,
    NULL
  },
  "handle-keep-alive",
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_method_info_ping_IN_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_method_info_ping_IN_ARG_pointers[] =
{
  &_print_backend_method_info_ping_IN_ARG_printer_id.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _print_backend_method_info_ping =
{
  {
    -1,
    (gchar *) "ping",
    (GDBusArgInfo **) &_print_backend_method_info_ping_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-ping",
  FALSE
};

static const GDBusMethodInfo * const _print_backend_method_info_pointers[] =
{
  &_print_backend_method_info_get_backend_name.parent_struct,
  &_print_backend_method_info_activate_backend.parent_struct,
  &_print_backend_method_info_get_default_printer.parent_struct,
  &_print_backend_method_info_get_printer_state.parent_struct,
  &_print_backend_method_info_is_accepting_jobs.parent_struct,
  &_print_backend_method_info_get_all_options.parent_struct,
  &_print_backend_method_info_get_active_jobs_count.parent_struct,
  &_print_backend_method_info_get_all_jobs.parent_struct,
  &_print_backend_method_info_cancel_job.parent_struct,
  &_print_backend_method_info_print_file.parent_struct,
  &_print_backend_method_info_replace.parent_struct,
  &_print_backend_method_info_keep_alive.parent_struct,
  &_print_backend_method_info_ping.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_printer_name =
{
  {
    -1,
    (gchar *) "printer_name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_printer_info =
{
  {
    -1,
    (gchar *) "printer_info",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_printer_location =
{
  {
    -1,
    (gchar *) "printer_location",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_printer_make_and_model =
{
  {
    -1,
    (gchar *) "printer_make_and_model",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_printer_is_accepting_jobs =
{
  {
    -1,
    (gchar *) "printer_is_accepting_jobs",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_printer_state =
{
  {
    -1,
    (gchar *) "printer_state",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_added_ARG_backend_name =
{
  {
    -1,
    (gchar *) "backend_name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_signal_info_printer_added_ARG_pointers[] =
{
  &_print_backend_signal_info_printer_added_ARG_printer_id.parent_struct,
  &_print_backend_signal_info_printer_added_ARG_printer_name.parent_struct,
  &_print_backend_signal_info_printer_added_ARG_printer_info.parent_struct,
  &_print_backend_signal_info_printer_added_ARG_printer_location.parent_struct,
  &_print_backend_signal_info_printer_added_ARG_printer_make_and_model.parent_struct,
  &_print_backend_signal_info_printer_added_ARG_printer_is_accepting_jobs.parent_struct,
  &_print_backend_signal_info_printer_added_ARG_printer_state.parent_struct,
  &_print_backend_signal_info_printer_added_ARG_backend_name.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _print_backend_signal_info_printer_added =
{
  {
    -1,
    (gchar *) "PrinterAdded",
    (GDBusArgInfo **) &_print_backend_signal_info_printer_added_ARG_pointers,
    NULL
  },
  "printer-added"
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_removed_ARG_printer_id =
{
  {
    -1,
    (gchar *) "printer_id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _print_backend_signal_info_printer_removed_ARG_backend_name =
{
  {
    -1,
    (gchar *) "backend_name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _print_backend_signal_info_printer_removed_ARG_pointers[] =
{
  &_print_backend_signal_info_printer_removed_ARG_printer_id.parent_struct,
  &_print_backend_signal_info_printer_removed_ARG_backend_name.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _print_backend_signal_info_printer_removed =
{
  {
    -1,
    (gchar *) "PrinterRemoved",
    (GDBusArgInfo **) &_print_backend_signal_info_printer_removed_ARG_pointers,
    NULL
  },
  "printer-removed"
};

static const GDBusSignalInfo * const _print_backend_signal_info_pointers[] =
{
  &_print_backend_signal_info_printer_added.parent_struct,
  &_print_backend_signal_info_printer_removed.parent_struct,
  NULL
};

static const _ExtendedGDBusInterfaceInfo _print_backend_interface_info =
{
  {
    -1,
    (gchar *) "org.openprinting.PrintBackend",
    (GDBusMethodInfo **) &_print_backend_method_info_pointers,
    (GDBusSignalInfo **) &_print_backend_signal_info_pointers,
    NULL,
    NULL
  },
  "print-backend",
};


/**
 * print_backend_interface_info:
 *
 * Gets a machine-readable description of the <link linkend="gdbus-interface-org-openprinting-PrintBackend.top_of_page">org.openprinting.PrintBackend</link> D-Bus interface.
 *
 * Returns: (transfer none): A #GDBusInterfaceInfo. Do not free.
 */
GDBusInterfaceInfo *
print_backend_interface_info (void)
{
  return (GDBusInterfaceInfo *) &_print_backend_interface_info.parent_struct;
}

/**
 * print_backend_override_properties:
 * @klass: The class structure for a #GObject derived class.
 * @property_id_begin: The property id to assign to the first overridden property.
 *
 * Overrides all #GObject properties in the #PrintBackend interface for a concrete class.
 * The properties are overridden in the order they are defined.
 *
 * Returns: The last property id.
 */
guint
print_backend_override_properties (GObjectClass *klass G_GNUC_UNUSED, guint property_id_begin)
{
  return property_id_begin - 1;
}



/**
 * PrintBackend:
 *
 * Abstract interface type for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintBackend.top_of_page">org.openprinting.PrintBackend</link>.
 */

/**
 * PrintBackendIface:
 * @parent_iface: The parent interface.
 * @handle_activate_backend: Handler for the #PrintBackend::handle-activate-backend signal.
 * @handle_cancel_job: Handler for the #PrintBackend::handle-cancel-job signal.
 * @handle_get_active_jobs_count: Handler for the #PrintBackend::handle-get-active-jobs-count signal.
 * @handle_get_all_jobs: Handler for the #PrintBackend::handle-get-all-jobs signal.
 * @handle_get_all_options: Handler for the #PrintBackend::handle-get-all-options signal.
 * @handle_get_backend_name: Handler for the #PrintBackend::handle-get-backend-name signal.
 * @handle_get_default_printer: Handler for the #PrintBackend::handle-get-default-printer signal.
 * @handle_get_printer_state: Handler for the #PrintBackend::handle-get-printer-state signal.
 * @handle_is_accepting_jobs: Handler for the #PrintBackend::handle-is-accepting-jobs signal.
 * @handle_keep_alive: Handler for the #PrintBackend::handle-keep-alive signal.
 * @handle_ping: Handler for the #PrintBackend::handle-ping signal.
 * @handle_print_file: Handler for the #PrintBackend::handle-print-file signal.
 * @handle_replace: Handler for the #PrintBackend::handle-replace signal.
 * @printer_added: Handler for the #PrintBackend::printer-added signal.
 * @printer_removed: Handler for the #PrintBackend::printer-removed signal.
 *
 * Virtual table for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintBackend.top_of_page">org.openprinting.PrintBackend</link>.
 */

typedef PrintBackendIface PrintBackendInterface;
G_DEFINE_INTERFACE (PrintBackend, print_backend, G_TYPE_OBJECT)

static void
print_backend_default_init (PrintBackendIface *iface)
{
  /* GObject signals for incoming D-Bus method calls: */
  /**
   * PrintBackend::handle-get-backend-name:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetBackendName">GetBackendName()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_get_backend_name() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-backend-name",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_get_backend_name),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * PrintBackend::handle-activate-backend:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.ActivateBackend">ActivateBackend()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_activate_backend() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-activate-backend",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_activate_backend),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * PrintBackend::handle-get-default-printer:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.getDefaultPrinter">getDefaultPrinter()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_get_default_printer() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-default-printer",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_get_default_printer),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * PrintBackend::handle-get-printer-state:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_printer_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.getPrinterState">getPrinterState()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_get_printer_state() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-printer-state",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_get_printer_state),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING);

  /**
   * PrintBackend::handle-is-accepting-jobs:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_printer_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.isAcceptingJobs">isAcceptingJobs()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_is_accepting_jobs() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-is-accepting-jobs",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_is_accepting_jobs),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING);

  /**
   * PrintBackend::handle-get-all-options:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_printer_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetAllOptions">GetAllOptions()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_get_all_options() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-all-options",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_get_all_options),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING);

  /**
   * PrintBackend::handle-get-active-jobs-count:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_printer_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.getActiveJobsCount">getActiveJobsCount()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_get_active_jobs_count() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-active-jobs-count",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_get_active_jobs_count),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING);

  /**
   * PrintBackend::handle-get-all-jobs:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_active_only: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.getAllJobs">getAllJobs()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_get_all_jobs() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-all-jobs",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_get_all_jobs),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_BOOLEAN);

  /**
   * PrintBackend::handle-cancel-job:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_job_id: Argument passed by remote caller.
   * @arg_printer_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.cancelJob">cancelJob()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_cancel_job() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-cancel-job",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_cancel_job),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    3,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING, G_TYPE_STRING);

  /**
   * PrintBackend::handle-print-file:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_printer_id: Argument passed by remote caller.
   * @arg_file_path_name: Argument passed by remote caller.
   * @arg_num_settings: Argument passed by remote caller.
   * @arg_settings: Argument passed by remote caller.
   * @arg_final_file_path: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.printFile">printFile()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_print_file() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-print-file",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_print_file),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    6,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, G_TYPE_VARIANT, G_TYPE_STRING);

  /**
   * PrintBackend::handle-replace:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_previous_dialog_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.replace">replace()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_replace() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-replace",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_replace),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING);

  /**
   * PrintBackend::handle-keep-alive:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.keepAlive">keepAlive()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_keep_alive() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-keep-alive",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_keep_alive),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * PrintBackend::handle-ping:
   * @object: A #PrintBackend.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_printer_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-openprinting-PrintBackend.ping">ping()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call print_backend_complete_ping() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-ping",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, handle_ping),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING);

  /* GObject signals for received D-Bus signals: */
  /**
   * PrintBackend::printer-added:
   * @object: A #PrintBackend.
   * @arg_printer_id: Argument.
   * @arg_printer_name: Argument.
   * @arg_printer_info: Argument.
   * @arg_printer_location: Argument.
   * @arg_printer_make_and_model: Argument.
   * @arg_printer_is_accepting_jobs: Argument.
   * @arg_printer_state: Argument.
   * @arg_backend_name: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintBackend.PrinterAdded">"PrinterAdded"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("printer-added",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, printer_added),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    8, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_BOOLEAN, G_TYPE_STRING, G_TYPE_STRING);

  /**
   * PrintBackend::printer-removed:
   * @object: A #PrintBackend.
   * @arg_printer_id: Argument.
   * @arg_backend_name: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintBackend.PrinterRemoved">"PrinterRemoved"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("printer-removed",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintBackendIface, printer_removed),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    2, G_TYPE_STRING, G_TYPE_STRING);

}

/**
 * print_backend_emit_printer_added:
 * @object: A #PrintBackend.
 * @arg_printer_id: Argument to pass with the signal.
 * @arg_printer_name: Argument to pass with the signal.
 * @arg_printer_info: Argument to pass with the signal.
 * @arg_printer_location: Argument to pass with the signal.
 * @arg_printer_make_and_model: Argument to pass with the signal.
 * @arg_printer_is_accepting_jobs: Argument to pass with the signal.
 * @arg_printer_state: Argument to pass with the signal.
 * @arg_backend_name: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintBackend.PrinterAdded">"PrinterAdded"</link> D-Bus signal.
 */
void
print_backend_emit_printer_added (
    PrintBackend *object,
    const gchar *arg_printer_id,
    const gchar *arg_printer_name,
    const gchar *arg_printer_info,
    const gchar *arg_printer_location,
    const gchar *arg_printer_make_and_model,
    gboolean arg_printer_is_accepting_jobs,
    const gchar *arg_printer_state,
    const gchar *arg_backend_name)
{
  g_signal_emit_by_name (object, "printer-added", arg_printer_id, arg_printer_name, arg_printer_info, arg_printer_location, arg_printer_make_and_model, arg_printer_is_accepting_jobs, arg_printer_state, arg_backend_name);
}

/**
 * print_backend_emit_printer_removed:
 * @object: A #PrintBackend.
 * @arg_printer_id: Argument to pass with the signal.
 * @arg_backend_name: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintBackend.PrinterRemoved">"PrinterRemoved"</link> D-Bus signal.
 */
void
print_backend_emit_printer_removed (
    PrintBackend *object,
    const gchar *arg_printer_id,
    const gchar *arg_backend_name)
{
  g_signal_emit_by_name (object, "printer-removed", arg_printer_id, arg_backend_name);
}

/**
 * print_backend_call_get_backend_name:
 * @proxy: A #PrintBackendProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetBackendName">GetBackendName()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_get_backend_name_finish() to get the result of the operation.
 *
 * See print_backend_call_get_backend_name_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_get_backend_name (
    PrintBackend *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "GetBackendName",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_get_backend_name_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_backend_name: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_get_backend_name().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_get_backend_name().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_backend_name_finish (
    PrintBackend *proxy,
    gchar **out_backend_name,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_backend_name);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_backend_name_sync:
 * @proxy: A #PrintBackendProxy.
 * @out_backend_name: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetBackendName">GetBackendName()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_get_backend_name() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_backend_name_sync (
    PrintBackend *proxy,
    gchar **out_backend_name,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "GetBackendName",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_backend_name);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_activate_backend:
 * @proxy: A #PrintBackendProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.ActivateBackend">ActivateBackend()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_activate_backend_finish() to get the result of the operation.
 *
 * See print_backend_call_activate_backend_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_activate_backend (
    PrintBackend *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "ActivateBackend",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_activate_backend_finish:
 * @proxy: A #PrintBackendProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_activate_backend().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_activate_backend().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_activate_backend_finish (
    PrintBackend *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_activate_backend_sync:
 * @proxy: A #PrintBackendProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.ActivateBackend">ActivateBackend()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_activate_backend() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_activate_backend_sync (
    PrintBackend *proxy,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "ActivateBackend",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_default_printer:
 * @proxy: A #PrintBackendProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getDefaultPrinter">getDefaultPrinter()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_get_default_printer_finish() to get the result of the operation.
 *
 * See print_backend_call_get_default_printer_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_get_default_printer (
    PrintBackend *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "getDefaultPrinter",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_get_default_printer_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_printer_id: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_get_default_printer().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_get_default_printer().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_default_printer_finish (
    PrintBackend *proxy,
    gchar **out_printer_id,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_printer_id);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_default_printer_sync:
 * @proxy: A #PrintBackendProxy.
 * @out_printer_id: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getDefaultPrinter">getDefaultPrinter()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_get_default_printer() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_default_printer_sync (
    PrintBackend *proxy,
    gchar **out_printer_id,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "getDefaultPrinter",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_printer_id);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_printer_state:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getPrinterState">getPrinterState()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_get_printer_state_finish() to get the result of the operation.
 *
 * See print_backend_call_get_printer_state_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_get_printer_state (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "getPrinterState",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_get_printer_state_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_state: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_get_printer_state().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_get_printer_state().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_printer_state_finish (
    PrintBackend *proxy,
    gchar **out_state,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_state);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_printer_state_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @out_state: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getPrinterState">getPrinterState()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_get_printer_state() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_printer_state_sync (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    gchar **out_state,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "getPrinterState",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_state);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_is_accepting_jobs:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.isAcceptingJobs">isAcceptingJobs()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_is_accepting_jobs_finish() to get the result of the operation.
 *
 * See print_backend_call_is_accepting_jobs_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_is_accepting_jobs (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "isAcceptingJobs",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_is_accepting_jobs_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_is_accepting: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_is_accepting_jobs().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_is_accepting_jobs().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_is_accepting_jobs_finish (
    PrintBackend *proxy,
    gboolean *out_is_accepting,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_is_accepting);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_is_accepting_jobs_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @out_is_accepting: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.isAcceptingJobs">isAcceptingJobs()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_is_accepting_jobs() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_is_accepting_jobs_sync (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    gboolean *out_is_accepting,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "isAcceptingJobs",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_is_accepting);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_all_options:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetAllOptions">GetAllOptions()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_get_all_options_finish() to get the result of the operation.
 *
 * See print_backend_call_get_all_options_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_get_all_options (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "GetAllOptions",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_get_all_options_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_num_options: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @out_options: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_get_all_options().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_get_all_options().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_all_options_finish (
    PrintBackend *proxy,
    gint *out_num_options,
    GVariant **out_options,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(i@a(ssia(s)))",
                 out_num_options,
                 out_options);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_all_options_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @out_num_options: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @out_options: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetAllOptions">GetAllOptions()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_get_all_options() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_all_options_sync (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    gint *out_num_options,
    GVariant **out_options,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "GetAllOptions",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(i@a(ssia(s)))",
                 out_num_options,
                 out_options);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_active_jobs_count:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getActiveJobsCount">getActiveJobsCount()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_get_active_jobs_count_finish() to get the result of the operation.
 *
 * See print_backend_call_get_active_jobs_count_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_get_active_jobs_count (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "getActiveJobsCount",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_get_active_jobs_count_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_job_count: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_get_active_jobs_count().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_get_active_jobs_count().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_active_jobs_count_finish (
    PrintBackend *proxy,
    gint *out_job_count,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(i)",
                 out_job_count);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_active_jobs_count_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @out_job_count: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getActiveJobsCount">getActiveJobsCount()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_get_active_jobs_count() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_active_jobs_count_sync (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    gint *out_job_count,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "getActiveJobsCount",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(i)",
                 out_job_count);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_all_jobs:
 * @proxy: A #PrintBackendProxy.
 * @arg_active_only: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getAllJobs">getAllJobs()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_get_all_jobs_finish() to get the result of the operation.
 *
 * See print_backend_call_get_all_jobs_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_get_all_jobs (
    PrintBackend *proxy,
    gboolean arg_active_only,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "getAllJobs",
    g_variant_new ("(b)",
                   arg_active_only),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_get_all_jobs_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_num_jobs: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @out_jobs: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_get_all_jobs().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_get_all_jobs().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_all_jobs_finish (
    PrintBackend *proxy,
    gint *out_num_jobs,
    GVariant **out_jobs,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(i@a(ssssssi))",
                 out_num_jobs,
                 out_jobs);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_get_all_jobs_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_active_only: Argument to pass with the method invocation.
 * @out_num_jobs: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @out_jobs: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.getAllJobs">getAllJobs()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_get_all_jobs() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_get_all_jobs_sync (
    PrintBackend *proxy,
    gboolean arg_active_only,
    gint *out_num_jobs,
    GVariant **out_jobs,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "getAllJobs",
    g_variant_new ("(b)",
                   arg_active_only),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(i@a(ssssssi))",
                 out_num_jobs,
                 out_jobs);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_cancel_job:
 * @proxy: A #PrintBackendProxy.
 * @arg_job_id: Argument to pass with the method invocation.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.cancelJob">cancelJob()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_cancel_job_finish() to get the result of the operation.
 *
 * See print_backend_call_cancel_job_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_cancel_job (
    PrintBackend *proxy,
    const gchar *arg_job_id,
    const gchar *arg_printer_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "cancelJob",
    g_variant_new ("(ss)",
                   arg_job_id,
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_cancel_job_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_status: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_cancel_job().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_cancel_job().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_cancel_job_finish (
    PrintBackend *proxy,
    gboolean *out_status,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_status);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_cancel_job_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_job_id: Argument to pass with the method invocation.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @out_status: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.cancelJob">cancelJob()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_cancel_job() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_cancel_job_sync (
    PrintBackend *proxy,
    const gchar *arg_job_id,
    const gchar *arg_printer_id,
    gboolean *out_status,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "cancelJob",
    g_variant_new ("(ss)",
                   arg_job_id,
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_status);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_print_file:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @arg_file_path_name: Argument to pass with the method invocation.
 * @arg_num_settings: Argument to pass with the method invocation.
 * @arg_settings: Argument to pass with the method invocation.
 * @arg_final_file_path: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.printFile">printFile()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_print_file_finish() to get the result of the operation.
 *
 * See print_backend_call_print_file_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_print_file (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    const gchar *arg_file_path_name,
    gint arg_num_settings,
    GVariant *arg_settings,
    const gchar *arg_final_file_path,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "printFile",
    g_variant_new ("(ssi@a(ss)s)",
                   arg_printer_id,
                   arg_file_path_name,
                   arg_num_settings,
                   arg_settings,
                   arg_final_file_path),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_print_file_finish:
 * @proxy: A #PrintBackendProxy.
 * @out_jobid: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_print_file().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_print_file().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_print_file_finish (
    PrintBackend *proxy,
    gchar **out_jobid,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_jobid);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_print_file_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @arg_file_path_name: Argument to pass with the method invocation.
 * @arg_num_settings: Argument to pass with the method invocation.
 * @arg_settings: Argument to pass with the method invocation.
 * @arg_final_file_path: Argument to pass with the method invocation.
 * @out_jobid: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.printFile">printFile()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_print_file() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_print_file_sync (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    const gchar *arg_file_path_name,
    gint arg_num_settings,
    GVariant *arg_settings,
    const gchar *arg_final_file_path,
    gchar **out_jobid,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "printFile",
    g_variant_new ("(ssi@a(ss)s)",
                   arg_printer_id,
                   arg_file_path_name,
                   arg_num_settings,
                   arg_settings,
                   arg_final_file_path),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_jobid);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_replace:
 * @proxy: A #PrintBackendProxy.
 * @arg_previous_dialog_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.replace">replace()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_replace_finish() to get the result of the operation.
 *
 * See print_backend_call_replace_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_replace (
    PrintBackend *proxy,
    const gchar *arg_previous_dialog_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "replace",
    g_variant_new ("(s)",
                   arg_previous_dialog_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_replace_finish:
 * @proxy: A #PrintBackendProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_replace().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_replace().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_replace_finish (
    PrintBackend *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_replace_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_previous_dialog_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.replace">replace()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_replace() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_replace_sync (
    PrintBackend *proxy,
    const gchar *arg_previous_dialog_id,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "replace",
    g_variant_new ("(s)",
                   arg_previous_dialog_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_keep_alive:
 * @proxy: A #PrintBackendProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.keepAlive">keepAlive()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_keep_alive_finish() to get the result of the operation.
 *
 * See print_backend_call_keep_alive_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_keep_alive (
    PrintBackend *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "keepAlive",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_keep_alive_finish:
 * @proxy: A #PrintBackendProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_keep_alive().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_keep_alive().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_keep_alive_finish (
    PrintBackend *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_keep_alive_sync:
 * @proxy: A #PrintBackendProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.keepAlive">keepAlive()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_keep_alive() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_keep_alive_sync (
    PrintBackend *proxy,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "keepAlive",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_ping:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.ping">ping()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_call_ping_finish() to get the result of the operation.
 *
 * See print_backend_call_ping_sync() for the synchronous, blocking version of this method.
 */
void
print_backend_call_ping (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "ping",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * print_backend_call_ping_finish:
 * @proxy: A #PrintBackendProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_call_ping().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with print_backend_call_ping().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_ping_finish (
    PrintBackend *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_call_ping_sync:
 * @proxy: A #PrintBackendProxy.
 * @arg_printer_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-openprinting-PrintBackend.ping">ping()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See print_backend_call_ping() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
print_backend_call_ping_sync (
    PrintBackend *proxy,
    const gchar *arg_printer_id,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "ping",
    g_variant_new ("(s)",
                   arg_printer_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * print_backend_complete_get_backend_name:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @backend_name: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetBackendName">GetBackendName()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_get_backend_name (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    const gchar *backend_name)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(s)",
                   backend_name));
}

/**
 * print_backend_complete_activate_backend:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.ActivateBackend">ActivateBackend()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_activate_backend (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * print_backend_complete_get_default_printer:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @printer_id: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.getDefaultPrinter">getDefaultPrinter()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_get_default_printer (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    const gchar *printer_id)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(s)",
                   printer_id));
}

/**
 * print_backend_complete_get_printer_state:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @state: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.getPrinterState">getPrinterState()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_get_printer_state (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    const gchar *state)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(s)",
                   state));
}

/**
 * print_backend_complete_is_accepting_jobs:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @is_accepting: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.isAcceptingJobs">isAcceptingJobs()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_is_accepting_jobs (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gboolean is_accepting)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(b)",
                   is_accepting));
}

/**
 * print_backend_complete_get_all_options:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @num_options: Parameter to return.
 * @options: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.GetAllOptions">GetAllOptions()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_get_all_options (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gint num_options,
    GVariant *options)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(i@a(ssia(s)))",
                   num_options,
                   options));
}

/**
 * print_backend_complete_get_active_jobs_count:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @job_count: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.getActiveJobsCount">getActiveJobsCount()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_get_active_jobs_count (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gint job_count)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(i)",
                   job_count));
}

/**
 * print_backend_complete_get_all_jobs:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @num_jobs: Parameter to return.
 * @jobs: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.getAllJobs">getAllJobs()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_get_all_jobs (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gint num_jobs,
    GVariant *jobs)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(i@a(ssssssi))",
                   num_jobs,
                   jobs));
}

/**
 * print_backend_complete_cancel_job:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @status: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.cancelJob">cancelJob()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_cancel_job (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gboolean status)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(b)",
                   status));
}

/**
 * print_backend_complete_print_file:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @jobid: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.printFile">printFile()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_print_file (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    const gchar *jobid)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(s)",
                   jobid));
}

/**
 * print_backend_complete_replace:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.replace">replace()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_replace (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * print_backend_complete_keep_alive:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.keepAlive">keepAlive()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_keep_alive (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * print_backend_complete_ping:
 * @object: A #PrintBackend.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-openprinting-PrintBackend.ping">ping()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
print_backend_complete_ping (
    PrintBackend *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/* ------------------------------------------------------------------------ */

/**
 * PrintBackendProxy:
 *
 * The #PrintBackendProxy structure contains only private data and should only be accessed using the provided API.
 */

/**
 * PrintBackendProxyClass:
 * @parent_class: The parent class.
 *
 * Class structure for #PrintBackendProxy.
 */

struct _PrintBackendProxyPrivate
{
  GData *qdata;
};

static void print_backend_proxy_iface_init (PrintBackendIface *iface);

#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (PrintBackendProxy, print_backend_proxy, G_TYPE_DBUS_PROXY,
                         G_ADD_PRIVATE (PrintBackendProxy)
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_BACKEND, print_backend_proxy_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (PrintBackendProxy, print_backend_proxy, G_TYPE_DBUS_PROXY,
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_BACKEND, print_backend_proxy_iface_init))

#endif
static void
print_backend_proxy_finalize (GObject *object)
{
  PrintBackendProxy *proxy = PRINT_BACKEND_PROXY (object);
  g_datalist_clear (&proxy->priv->qdata);
  G_OBJECT_CLASS (print_backend_proxy_parent_class)->finalize (object);
}

static void
print_backend_proxy_get_property (GObject      *object G_GNUC_UNUSED,
  guint         prop_id G_GNUC_UNUSED,
  GValue       *value G_GNUC_UNUSED,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
print_backend_proxy_set_property (GObject      *object G_GNUC_UNUSED,
  guint         prop_id G_GNUC_UNUSED,
  const GValue *value G_GNUC_UNUSED,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
print_backend_proxy_g_signal (GDBusProxy *proxy,
  const gchar *sender_name G_GNUC_UNUSED,
  const gchar *signal_name,
  GVariant *parameters)
{
  _ExtendedGDBusSignalInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  gsize n;
  guint signal_id;
  info = (_ExtendedGDBusSignalInfo *) g_dbus_interface_info_lookup_signal ((GDBusInterfaceInfo *) &_print_backend_interface_info.parent_struct, signal_name);
  if (info == NULL)
    return;
  num_params = g_variant_n_children (parameters);
  paramv = g_new0 (GValue, num_params + 1);
  g_value_init (&paramv[0], TYPE_PRINT_BACKEND);
  g_value_set_object (&paramv[0], proxy);
  g_variant_iter_init (&iter, parameters);
  n = 1;
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.args[n - 1];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, TYPE_PRINT_BACKEND);
  g_signal_emitv (paramv, signal_id, 0, NULL);
  for (n = 0; n < num_params + 1; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static void
print_backend_proxy_g_properties_changed (GDBusProxy *_proxy,
  GVariant *changed_properties,
  const gchar *const *invalidated_properties)
{
  PrintBackendProxy *proxy = PRINT_BACKEND_PROXY (_proxy);
  guint n;
  const gchar *key;
  GVariantIter *iter;
  _ExtendedGDBusPropertyInfo *info;
  g_variant_get (changed_properties, "a{sv}", &iter);
  while (g_variant_iter_next (iter, "{&sv}", &key, NULL))
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_backend_interface_info.parent_struct, key);
      g_datalist_remove_data (&proxy->priv->qdata, key);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
  g_variant_iter_free (iter);
  for (n = 0; invalidated_properties[n] != NULL; n++)
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_backend_interface_info.parent_struct, invalidated_properties[n]);
      g_datalist_remove_data (&proxy->priv->qdata, invalidated_properties[n]);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
}

static void
print_backend_proxy_init (PrintBackendProxy *proxy)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  proxy->priv = print_backend_proxy_get_instance_private (proxy);
#else
  proxy->priv = G_TYPE_INSTANCE_GET_PRIVATE (proxy, TYPE_PRINT_BACKEND_PROXY, PrintBackendProxyPrivate);
#endif

  g_dbus_proxy_set_interface_info (G_DBUS_PROXY (proxy), print_backend_interface_info ());
}

static void
print_backend_proxy_class_init (PrintBackendProxyClass *klass)
{
  GObjectClass *gobject_class;
  GDBusProxyClass *proxy_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize     = print_backend_proxy_finalize;
  gobject_class->get_property = print_backend_proxy_get_property;
  gobject_class->set_property = print_backend_proxy_set_property;

  proxy_class = G_DBUS_PROXY_CLASS (klass);
  proxy_class->g_signal = print_backend_proxy_g_signal;
  proxy_class->g_properties_changed = print_backend_proxy_g_properties_changed;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (PrintBackendProxyPrivate));
#endif
}

static void
print_backend_proxy_iface_init (PrintBackendIface *iface G_GNUC_UNUSED)
{
}

/**
 * print_backend_proxy_new:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintBackend.top_of_page">org.openprinting.PrintBackend</link>. See g_dbus_proxy_new() for more details.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_proxy_new_finish() to get the result of the operation.
 *
 * See print_backend_proxy_new_sync() for the synchronous, blocking version of this constructor.
 */
void
print_backend_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (TYPE_PRINT_BACKEND_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintBackend", NULL);
}

/**
 * print_backend_proxy_new_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_proxy_new().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with print_backend_proxy_new().
 *
 * Returns: (transfer full) (type PrintBackendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintBackend *
print_backend_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return PRINT_BACKEND (ret);
  else
    return NULL;
}

/**
 * print_backend_proxy_new_sync:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Synchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintBackend.top_of_page">org.openprinting.PrintBackend</link>. See g_dbus_proxy_new_sync() for more details.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See print_backend_proxy_new() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type PrintBackendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintBackend *
print_backend_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (TYPE_PRINT_BACKEND_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintBackend", NULL);
  if (ret != NULL)
    return PRINT_BACKEND (ret);
  else
    return NULL;
}


/**
 * print_backend_proxy_new_for_bus:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Like print_backend_proxy_new() but takes a #GBusType instead of a #GDBusConnection.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_backend_proxy_new_for_bus_finish() to get the result of the operation.
 *
 * See print_backend_proxy_new_for_bus_sync() for the synchronous, blocking version of this constructor.
 */
void
print_backend_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (TYPE_PRINT_BACKEND_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintBackend", NULL);
}

/**
 * print_backend_proxy_new_for_bus_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_backend_proxy_new_for_bus().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with print_backend_proxy_new_for_bus().
 *
 * Returns: (transfer full) (type PrintBackendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintBackend *
print_backend_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return PRINT_BACKEND (ret);
  else
    return NULL;
}

/**
 * print_backend_proxy_new_for_bus_sync:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Like print_backend_proxy_new_sync() but takes a #GBusType instead of a #GDBusConnection.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See print_backend_proxy_new_for_bus() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type PrintBackendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintBackend *
print_backend_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (TYPE_PRINT_BACKEND_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintBackend", NULL);
  if (ret != NULL)
    return PRINT_BACKEND (ret);
  else
    return NULL;
}


/* ------------------------------------------------------------------------ */

/**
 * PrintBackendSkeleton:
 *
 * The #PrintBackendSkeleton structure contains only private data and should only be accessed using the provided API.
 */

/**
 * PrintBackendSkeletonClass:
 * @parent_class: The parent class.
 *
 * Class structure for #PrintBackendSkeleton.
 */

struct _PrintBackendSkeletonPrivate
{
  GValue *properties;
  GList *changed_properties;
  GSource *changed_properties_idle_source;
  GMainContext *context;
  GMutex lock;
};

static void
_print_backend_skeleton_handle_method_call (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name,
  const gchar *method_name,
  GVariant *parameters,
  GDBusMethodInvocation *invocation,
  gpointer user_data)
{
  PrintBackendSkeleton *skeleton = PRINT_BACKEND_SKELETON (user_data);
  _ExtendedGDBusMethodInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  guint num_extra;
  gsize n;
  guint signal_id;
  GValue return_value = G_VALUE_INIT;
  info = (_ExtendedGDBusMethodInfo *) g_dbus_method_invocation_get_method_info (invocation);
  g_assert (info != NULL);
  num_params = g_variant_n_children (parameters);
  num_extra = info->pass_fdlist ? 3 : 2;  paramv = g_new0 (GValue, num_params + num_extra);
  n = 0;
  g_value_init (&paramv[n], TYPE_PRINT_BACKEND);
  g_value_set_object (&paramv[n++], skeleton);
  g_value_init (&paramv[n], G_TYPE_DBUS_METHOD_INVOCATION);
  g_value_set_object (&paramv[n++], invocation);
  if (info->pass_fdlist)
    {
#ifdef G_OS_UNIX
      g_value_init (&paramv[n], G_TYPE_UNIX_FD_LIST);
      g_value_set_object (&paramv[n++], g_dbus_message_get_unix_fd_list (g_dbus_method_invocation_get_message (invocation)));
#else
      g_assert_not_reached ();
#endif
    }
  g_variant_iter_init (&iter, parameters);
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.in_args[n - num_extra];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, TYPE_PRINT_BACKEND);
  g_value_init (&return_value, G_TYPE_BOOLEAN);
  g_signal_emitv (paramv, signal_id, 0, &return_value);
  if (!g_value_get_boolean (&return_value))
    g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, "Method %s is not implemented on interface %s", method_name, interface_name);
  g_value_unset (&return_value);
  for (n = 0; n < num_params + num_extra; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static GVariant *
_print_backend_skeleton_handle_get_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GError **error,
  gpointer user_data)
{
  PrintBackendSkeleton *skeleton = PRINT_BACKEND_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  GVariant *ret;
  ret = NULL;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_backend_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      g_value_init (&value, pspec->value_type);
      g_object_get_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      ret = g_dbus_gvalue_to_gvariant (&value, G_VARIANT_TYPE (info->parent_struct.signature));
      g_value_unset (&value);
    }
  return ret;
}

static gboolean
_print_backend_skeleton_handle_set_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GVariant *variant,
  GError **error,
  gpointer user_data)
{
  PrintBackendSkeleton *skeleton = PRINT_BACKEND_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  gboolean ret;
  ret = FALSE;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_backend_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      if (info->use_gvariant)
        g_value_set_variant (&value, variant);
      else
        g_dbus_gvariant_to_gvalue (variant, &value);
      g_object_set_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      g_value_unset (&value);
      ret = TRUE;
    }
  return ret;
}

static const GDBusInterfaceVTable _print_backend_skeleton_vtable =
{
  _print_backend_skeleton_handle_method_call,
  _print_backend_skeleton_handle_get_property,
  _print_backend_skeleton_handle_set_property,
  {NULL}
};

static GDBusInterfaceInfo *
print_backend_skeleton_dbus_interface_get_info (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return print_backend_interface_info ();
}

static GDBusInterfaceVTable *
print_backend_skeleton_dbus_interface_get_vtable (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return (GDBusInterfaceVTable *) &_print_backend_skeleton_vtable;
}

static GVariant *
print_backend_skeleton_dbus_interface_get_properties (GDBusInterfaceSkeleton *_skeleton)
{
  PrintBackendSkeleton *skeleton = PRINT_BACKEND_SKELETON (_skeleton);

  GVariantBuilder builder;
  guint n;
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  if (_print_backend_interface_info.parent_struct.properties == NULL)
    goto out;
  for (n = 0; _print_backend_interface_info.parent_struct.properties[n] != NULL; n++)
    {
      GDBusPropertyInfo *info = _print_backend_interface_info.parent_struct.properties[n];
      if (info->flags & G_DBUS_PROPERTY_INFO_FLAGS_READABLE)
        {
          GVariant *value;
          value = _print_backend_skeleton_handle_get_property (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)), NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintBackend", info->name, NULL, skeleton);
          if (value != NULL)
            {
              g_variant_take_ref (value);
              g_variant_builder_add (&builder, "{sv}", info->name, value);
              g_variant_unref (value);
            }
        }
    }
out:
  return g_variant_builder_end (&builder);
}

static void
print_backend_skeleton_dbus_interface_flush (GDBusInterfaceSkeleton *_skeleton G_GNUC_UNUSED)
{
}

static void
_print_backend_on_signal_printer_added (
    PrintBackend *object,
    const gchar *arg_printer_id,
    const gchar *arg_printer_name,
    const gchar *arg_printer_info,
    const gchar *arg_printer_location,
    const gchar *arg_printer_make_and_model,
    gboolean arg_printer_is_accepting_jobs,
    const gchar *arg_printer_state,
    const gchar *arg_backend_name)
{
  PrintBackendSkeleton *skeleton = PRINT_BACKEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(sssssbss)",
                   arg_printer_id,
                   arg_printer_name,
                   arg_printer_info,
                   arg_printer_location,
                   arg_printer_make_and_model,
                   arg_printer_is_accepting_jobs,
                   arg_printer_state,
                   arg_backend_name));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintBackend", "PrinterAdded",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_print_backend_on_signal_printer_removed (
    PrintBackend *object,
    const gchar *arg_printer_id,
    const gchar *arg_backend_name)
{
  PrintBackendSkeleton *skeleton = PRINT_BACKEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(ss)",
                   arg_printer_id,
                   arg_backend_name));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintBackend", "PrinterRemoved",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void print_backend_skeleton_iface_init (PrintBackendIface *iface);
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (PrintBackendSkeleton, print_backend_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_ADD_PRIVATE (PrintBackendSkeleton)
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_BACKEND, print_backend_skeleton_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (PrintBackendSkeleton, print_backend_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_BACKEND, print_backend_skeleton_iface_init))

#endif
static void
print_backend_skeleton_finalize (GObject *object)
{
  PrintBackendSkeleton *skeleton = PRINT_BACKEND_SKELETON (object);
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    g_source_destroy (skeleton->priv->changed_properties_idle_source);
  g_main_context_unref (skeleton->priv->context);
  g_mutex_clear (&skeleton->priv->lock);
  G_OBJECT_CLASS (print_backend_skeleton_parent_class)->finalize (object);
}

static void
print_backend_skeleton_init (PrintBackendSkeleton *skeleton)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  skeleton->priv = print_backend_skeleton_get_instance_private (skeleton);
#else
  skeleton->priv = G_TYPE_INSTANCE_GET_PRIVATE (skeleton, TYPE_PRINT_BACKEND_SKELETON, PrintBackendSkeletonPrivate);
#endif

  g_mutex_init (&skeleton->priv->lock);
  skeleton->priv->context = g_main_context_ref_thread_default ();
}

static void
print_backend_skeleton_class_init (PrintBackendSkeletonClass *klass)
{
  GObjectClass *gobject_class;
  GDBusInterfaceSkeletonClass *skeleton_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = print_backend_skeleton_finalize;

  skeleton_class = G_DBUS_INTERFACE_SKELETON_CLASS (klass);
  skeleton_class->get_info = print_backend_skeleton_dbus_interface_get_info;
  skeleton_class->get_properties = print_backend_skeleton_dbus_interface_get_properties;
  skeleton_class->flush = print_backend_skeleton_dbus_interface_flush;
  skeleton_class->get_vtable = print_backend_skeleton_dbus_interface_get_vtable;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (PrintBackendSkeletonPrivate));
#endif
}

static void
print_backend_skeleton_iface_init (PrintBackendIface *iface)
{
  iface->printer_added = _print_backend_on_signal_printer_added;
  iface->printer_removed = _print_backend_on_signal_printer_removed;
}

/**
 * print_backend_skeleton_new:
 *
 * Creates a skeleton object for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintBackend.top_of_page">org.openprinting.PrintBackend</link>.
 *
 * Returns: (transfer full) (type PrintBackendSkeleton): The skeleton object.
 */
PrintBackend *
print_backend_skeleton_new (void)
{
  return PRINT_BACKEND (g_object_new (TYPE_PRINT_BACKEND_SKELETON, NULL));
}

