/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "frontend_interface.h"

#include <string.h>
#ifdef G_OS_UNIX
#  include <gio/gunixfdlist.h>
#endif

typedef struct
{
  GDBusArgInfo parent_struct;
  gboolean use_gvariant;
} _ExtendedGDBusArgInfo;

typedef struct
{
  GDBusMethodInfo parent_struct;
  const gchar *signal_name;
  gboolean pass_fdlist;
} _ExtendedGDBusMethodInfo;

typedef struct
{
  GDBusSignalInfo parent_struct;
  const gchar *signal_name;
} _ExtendedGDBusSignalInfo;

typedef struct
{
  GDBusPropertyInfo parent_struct;
  const gchar *hyphen_name;
  guint use_gvariant : 1;
  guint emits_changed_signal : 1;
} _ExtendedGDBusPropertyInfo;

typedef struct
{
  GDBusInterfaceInfo parent_struct;
  const gchar *hyphen_name;
} _ExtendedGDBusInterfaceInfo;

typedef struct
{
  const _ExtendedGDBusPropertyInfo *info;
  guint prop_id;
  GValue orig_value; /* the value before the change */
} ChangedProperty;

static void
_changed_property_free (ChangedProperty *data)
{
  g_value_unset (&data->orig_value);
  g_free (data);
}

static gboolean
_g_strv_equal0 (gchar **a, gchar **b)
{
  gboolean ret = FALSE;
  guint n;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  if (g_strv_length (a) != g_strv_length (b))
    goto out;
  for (n = 0; a[n] != NULL; n++)
    if (g_strcmp0 (a[n], b[n]) != 0)
      goto out;
  ret = TRUE;
out:
  return ret;
}

static gboolean
_g_variant_equal0 (GVariant *a, GVariant *b)
{
  gboolean ret = FALSE;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  ret = g_variant_equal (a, b);
out:
  return ret;
}

G_GNUC_UNUSED static gboolean
_g_value_equal (const GValue *a, const GValue *b)
{
  gboolean ret = FALSE;
  g_assert (G_VALUE_TYPE (a) == G_VALUE_TYPE (b));
  switch (G_VALUE_TYPE (a))
    {
      case G_TYPE_BOOLEAN:
        ret = (g_value_get_boolean (a) == g_value_get_boolean (b));
        break;
      case G_TYPE_UCHAR:
        ret = (g_value_get_uchar (a) == g_value_get_uchar (b));
        break;
      case G_TYPE_INT:
        ret = (g_value_get_int (a) == g_value_get_int (b));
        break;
      case G_TYPE_UINT:
        ret = (g_value_get_uint (a) == g_value_get_uint (b));
        break;
      case G_TYPE_INT64:
        ret = (g_value_get_int64 (a) == g_value_get_int64 (b));
        break;
      case G_TYPE_UINT64:
        ret = (g_value_get_uint64 (a) == g_value_get_uint64 (b));
        break;
      case G_TYPE_DOUBLE:
        {
          /* Avoid -Wfloat-equal warnings by doing a direct bit compare */
          gdouble da = g_value_get_double (a);
          gdouble db = g_value_get_double (b);
          ret = memcmp (&da, &db, sizeof (gdouble)) == 0;
        }
        break;
      case G_TYPE_STRING:
        ret = (g_strcmp0 (g_value_get_string (a), g_value_get_string (b)) == 0);
        break;
      case G_TYPE_VARIANT:
        ret = _g_variant_equal0 (g_value_get_variant (a), g_value_get_variant (b));
        break;
      default:
        if (G_VALUE_TYPE (a) == G_TYPE_STRV)
          ret = _g_strv_equal0 (g_value_get_boxed (a), g_value_get_boxed (b));
        else
          g_critical ("_g_value_equal() does not handle type %s", g_type_name (G_VALUE_TYPE (a)));
        break;
    }
  return ret;
}

/* ------------------------------------------------------------------------
 * Code for interface org.openprinting.PrintFrontend
 * ------------------------------------------------------------------------
 */

/**
 * SECTION:PrintFrontend
 * @title: PrintFrontend
 * @short_description: Generated C code for the org.openprinting.PrintFrontend D-Bus interface
 *
 * This section contains code for working with the <link linkend="gdbus-interface-org-openprinting-PrintFrontend.top_of_page">org.openprinting.PrintFrontend</link> D-Bus interface in C.
 */

/* ---- Introspection data for org.openprinting.PrintFrontend ---- */

static const _ExtendedGDBusSignalInfo _print_frontend_signal_info_refresh_backend =
{
  {
    -1,
    (gchar *) "RefreshBackend",
    NULL,
    NULL
  },
  "refresh-backend"
};

static const _ExtendedGDBusSignalInfo _print_frontend_signal_info_stop_listing =
{
  {
    -1,
    (gchar *) "StopListing",
    NULL,
    NULL
  },
  "stop-listing"
};

static const _ExtendedGDBusSignalInfo _print_frontend_signal_info_hide_remote_printers_cups =
{
  {
    -1,
    (gchar *) "HideRemotePrintersCUPS",
    NULL,
    NULL
  },
  "hide-remote-printers-cups"
};

static const _ExtendedGDBusSignalInfo _print_frontend_signal_info_unhide_remote_printers_cups =
{
  {
    -1,
    (gchar *) "UnhideRemotePrintersCUPS",
    NULL,
    NULL
  },
  "unhide-remote-printers-cups"
};

static const _ExtendedGDBusSignalInfo _print_frontend_signal_info_hide_temporary_printers_cups =
{
  {
    -1,
    (gchar *) "HideTemporaryPrintersCUPS",
    NULL,
    NULL
  },
  "hide-temporary-printers-cups"
};

static const _ExtendedGDBusSignalInfo _print_frontend_signal_info_unhide_temporary_printers_cups =
{
  {
    -1,
    (gchar *) "UnhideTemporaryPrintersCUPS",
    NULL,
    NULL
  },
  "unhide-temporary-printers-cups"
};

static const GDBusSignalInfo * const _print_frontend_signal_info_pointers[] =
{
  &_print_frontend_signal_info_refresh_backend.parent_struct,
  &_print_frontend_signal_info_stop_listing.parent_struct,
  &_print_frontend_signal_info_hide_remote_printers_cups.parent_struct,
  &_print_frontend_signal_info_unhide_remote_printers_cups.parent_struct,
  &_print_frontend_signal_info_hide_temporary_printers_cups.parent_struct,
  &_print_frontend_signal_info_unhide_temporary_printers_cups.parent_struct,
  NULL
};

static const _ExtendedGDBusInterfaceInfo _print_frontend_interface_info =
{
  {
    -1,
    (gchar *) "org.openprinting.PrintFrontend",
    NULL,
    (GDBusSignalInfo **) &_print_frontend_signal_info_pointers,
    NULL,
    NULL
  },
  "print-frontend",
};


/**
 * print_frontend_interface_info:
 *
 * Gets a machine-readable description of the <link linkend="gdbus-interface-org-openprinting-PrintFrontend.top_of_page">org.openprinting.PrintFrontend</link> D-Bus interface.
 *
 * Returns: (transfer none): A #GDBusInterfaceInfo. Do not free.
 */
GDBusInterfaceInfo *
print_frontend_interface_info (void)
{
  return (GDBusInterfaceInfo *) &_print_frontend_interface_info.parent_struct;
}

/**
 * print_frontend_override_properties:
 * @klass: The class structure for a #GObject derived class.
 * @property_id_begin: The property id to assign to the first overridden property.
 *
 * Overrides all #GObject properties in the #PrintFrontend interface for a concrete class.
 * The properties are overridden in the order they are defined.
 *
 * Returns: The last property id.
 */
guint
print_frontend_override_properties (GObjectClass *klass G_GNUC_UNUSED, guint property_id_begin)
{
  return property_id_begin - 1;
}



/**
 * PrintFrontend:
 *
 * Abstract interface type for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintFrontend.top_of_page">org.openprinting.PrintFrontend</link>.
 */

/**
 * PrintFrontendIface:
 * @parent_iface: The parent interface.
 * @hide_remote_printers_cups: Handler for the #PrintFrontend::hide-remote-printers-cups signal.
 * @hide_temporary_printers_cups: Handler for the #PrintFrontend::hide-temporary-printers-cups signal.
 * @refresh_backend: Handler for the #PrintFrontend::refresh-backend signal.
 * @stop_listing: Handler for the #PrintFrontend::stop-listing signal.
 * @unhide_remote_printers_cups: Handler for the #PrintFrontend::unhide-remote-printers-cups signal.
 * @unhide_temporary_printers_cups: Handler for the #PrintFrontend::unhide-temporary-printers-cups signal.
 *
 * Virtual table for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintFrontend.top_of_page">org.openprinting.PrintFrontend</link>.
 */

typedef PrintFrontendIface PrintFrontendInterface;
G_DEFINE_INTERFACE (PrintFrontend, print_frontend, G_TYPE_OBJECT)

static void
print_frontend_default_init (PrintFrontendIface *iface)
{
  /* GObject signals for received D-Bus signals: */
  /**
   * PrintFrontend::refresh-backend:
   * @object: A #PrintFrontend.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintFrontend.RefreshBackend">"RefreshBackend"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("refresh-backend",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintFrontendIface, refresh_backend),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * PrintFrontend::stop-listing:
   * @object: A #PrintFrontend.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintFrontend.StopListing">"StopListing"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("stop-listing",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintFrontendIface, stop_listing),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * PrintFrontend::hide-remote-printers-cups:
   * @object: A #PrintFrontend.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintFrontend.HideRemotePrintersCUPS">"HideRemotePrintersCUPS"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("hide-remote-printers-cups",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintFrontendIface, hide_remote_printers_cups),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * PrintFrontend::unhide-remote-printers-cups:
   * @object: A #PrintFrontend.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintFrontend.UnhideRemotePrintersCUPS">"UnhideRemotePrintersCUPS"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("unhide-remote-printers-cups",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintFrontendIface, unhide_remote_printers_cups),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * PrintFrontend::hide-temporary-printers-cups:
   * @object: A #PrintFrontend.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintFrontend.HideTemporaryPrintersCUPS">"HideTemporaryPrintersCUPS"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("hide-temporary-printers-cups",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintFrontendIface, hide_temporary_printers_cups),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * PrintFrontend::unhide-temporary-printers-cups:
   * @object: A #PrintFrontend.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-openprinting-PrintFrontend.UnhideTemporaryPrintersCUPS">"UnhideTemporaryPrintersCUPS"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("unhide-temporary-printers-cups",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (PrintFrontendIface, unhide_temporary_printers_cups),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

}

/**
 * print_frontend_emit_refresh_backend:
 * @object: A #PrintFrontend.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintFrontend.RefreshBackend">"RefreshBackend"</link> D-Bus signal.
 */
void
print_frontend_emit_refresh_backend (
    PrintFrontend *object)
{
  g_signal_emit_by_name (object, "refresh-backend");
}

/**
 * print_frontend_emit_stop_listing:
 * @object: A #PrintFrontend.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintFrontend.StopListing">"StopListing"</link> D-Bus signal.
 */
void
print_frontend_emit_stop_listing (
    PrintFrontend *object)
{
  g_signal_emit_by_name (object, "stop-listing");
}

/**
 * print_frontend_emit_hide_remote_printers_cups:
 * @object: A #PrintFrontend.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintFrontend.HideRemotePrintersCUPS">"HideRemotePrintersCUPS"</link> D-Bus signal.
 */
void
print_frontend_emit_hide_remote_printers_cups (
    PrintFrontend *object)
{
  g_signal_emit_by_name (object, "hide-remote-printers-cups");
}

/**
 * print_frontend_emit_unhide_remote_printers_cups:
 * @object: A #PrintFrontend.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintFrontend.UnhideRemotePrintersCUPS">"UnhideRemotePrintersCUPS"</link> D-Bus signal.
 */
void
print_frontend_emit_unhide_remote_printers_cups (
    PrintFrontend *object)
{
  g_signal_emit_by_name (object, "unhide-remote-printers-cups");
}

/**
 * print_frontend_emit_hide_temporary_printers_cups:
 * @object: A #PrintFrontend.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintFrontend.HideTemporaryPrintersCUPS">"HideTemporaryPrintersCUPS"</link> D-Bus signal.
 */
void
print_frontend_emit_hide_temporary_printers_cups (
    PrintFrontend *object)
{
  g_signal_emit_by_name (object, "hide-temporary-printers-cups");
}

/**
 * print_frontend_emit_unhide_temporary_printers_cups:
 * @object: A #PrintFrontend.
 *
 * Emits the <link linkend="gdbus-signal-org-openprinting-PrintFrontend.UnhideTemporaryPrintersCUPS">"UnhideTemporaryPrintersCUPS"</link> D-Bus signal.
 */
void
print_frontend_emit_unhide_temporary_printers_cups (
    PrintFrontend *object)
{
  g_signal_emit_by_name (object, "unhide-temporary-printers-cups");
}

/* ------------------------------------------------------------------------ */

/**
 * PrintFrontendProxy:
 *
 * The #PrintFrontendProxy structure contains only private data and should only be accessed using the provided API.
 */

/**
 * PrintFrontendProxyClass:
 * @parent_class: The parent class.
 *
 * Class structure for #PrintFrontendProxy.
 */

struct _PrintFrontendProxyPrivate
{
  GData *qdata;
};

static void print_frontend_proxy_iface_init (PrintFrontendIface *iface);

#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (PrintFrontendProxy, print_frontend_proxy, G_TYPE_DBUS_PROXY,
                         G_ADD_PRIVATE (PrintFrontendProxy)
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_FRONTEND, print_frontend_proxy_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (PrintFrontendProxy, print_frontend_proxy, G_TYPE_DBUS_PROXY,
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_FRONTEND, print_frontend_proxy_iface_init))

#endif
static void
print_frontend_proxy_finalize (GObject *object)
{
  PrintFrontendProxy *proxy = PRINT_FRONTEND_PROXY (object);
  g_datalist_clear (&proxy->priv->qdata);
  G_OBJECT_CLASS (print_frontend_proxy_parent_class)->finalize (object);
}

static void
print_frontend_proxy_get_property (GObject      *object G_GNUC_UNUSED,
  guint         prop_id G_GNUC_UNUSED,
  GValue       *value G_GNUC_UNUSED,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
print_frontend_proxy_set_property (GObject      *object G_GNUC_UNUSED,
  guint         prop_id G_GNUC_UNUSED,
  const GValue *value G_GNUC_UNUSED,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
print_frontend_proxy_g_signal (GDBusProxy *proxy,
  const gchar *sender_name G_GNUC_UNUSED,
  const gchar *signal_name,
  GVariant *parameters)
{
  _ExtendedGDBusSignalInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  gsize n;
  guint signal_id;
  info = (_ExtendedGDBusSignalInfo *) g_dbus_interface_info_lookup_signal ((GDBusInterfaceInfo *) &_print_frontend_interface_info.parent_struct, signal_name);
  if (info == NULL)
    return;
  num_params = g_variant_n_children (parameters);
  paramv = g_new0 (GValue, num_params + 1);
  g_value_init (&paramv[0], TYPE_PRINT_FRONTEND);
  g_value_set_object (&paramv[0], proxy);
  g_variant_iter_init (&iter, parameters);
  n = 1;
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.args[n - 1];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, TYPE_PRINT_FRONTEND);
  g_signal_emitv (paramv, signal_id, 0, NULL);
  for (n = 0; n < num_params + 1; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static void
print_frontend_proxy_g_properties_changed (GDBusProxy *_proxy,
  GVariant *changed_properties,
  const gchar *const *invalidated_properties)
{
  PrintFrontendProxy *proxy = PRINT_FRONTEND_PROXY (_proxy);
  guint n;
  const gchar *key;
  GVariantIter *iter;
  _ExtendedGDBusPropertyInfo *info;
  g_variant_get (changed_properties, "a{sv}", &iter);
  while (g_variant_iter_next (iter, "{&sv}", &key, NULL))
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_frontend_interface_info.parent_struct, key);
      g_datalist_remove_data (&proxy->priv->qdata, key);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
  g_variant_iter_free (iter);
  for (n = 0; invalidated_properties[n] != NULL; n++)
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_frontend_interface_info.parent_struct, invalidated_properties[n]);
      g_datalist_remove_data (&proxy->priv->qdata, invalidated_properties[n]);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
}

static void
print_frontend_proxy_init (PrintFrontendProxy *proxy)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  proxy->priv = print_frontend_proxy_get_instance_private (proxy);
#else
  proxy->priv = G_TYPE_INSTANCE_GET_PRIVATE (proxy, TYPE_PRINT_FRONTEND_PROXY, PrintFrontendProxyPrivate);
#endif

  g_dbus_proxy_set_interface_info (G_DBUS_PROXY (proxy), print_frontend_interface_info ());
}

static void
print_frontend_proxy_class_init (PrintFrontendProxyClass *klass)
{
  GObjectClass *gobject_class;
  GDBusProxyClass *proxy_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize     = print_frontend_proxy_finalize;
  gobject_class->get_property = print_frontend_proxy_get_property;
  gobject_class->set_property = print_frontend_proxy_set_property;

  proxy_class = G_DBUS_PROXY_CLASS (klass);
  proxy_class->g_signal = print_frontend_proxy_g_signal;
  proxy_class->g_properties_changed = print_frontend_proxy_g_properties_changed;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (PrintFrontendProxyPrivate));
#endif
}

static void
print_frontend_proxy_iface_init (PrintFrontendIface *iface G_GNUC_UNUSED)
{
}

/**
 * print_frontend_proxy_new:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintFrontend.top_of_page">org.openprinting.PrintFrontend</link>. See g_dbus_proxy_new() for more details.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_frontend_proxy_new_finish() to get the result of the operation.
 *
 * See print_frontend_proxy_new_sync() for the synchronous, blocking version of this constructor.
 */
void
print_frontend_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (TYPE_PRINT_FRONTEND_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintFrontend", NULL);
}

/**
 * print_frontend_proxy_new_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_frontend_proxy_new().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with print_frontend_proxy_new().
 *
 * Returns: (transfer full) (type PrintFrontendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintFrontend *
print_frontend_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return PRINT_FRONTEND (ret);
  else
    return NULL;
}

/**
 * print_frontend_proxy_new_sync:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Synchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintFrontend.top_of_page">org.openprinting.PrintFrontend</link>. See g_dbus_proxy_new_sync() for more details.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See print_frontend_proxy_new() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type PrintFrontendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintFrontend *
print_frontend_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (TYPE_PRINT_FRONTEND_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintFrontend", NULL);
  if (ret != NULL)
    return PRINT_FRONTEND (ret);
  else
    return NULL;
}


/**
 * print_frontend_proxy_new_for_bus:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Like print_frontend_proxy_new() but takes a #GBusType instead of a #GDBusConnection.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call print_frontend_proxy_new_for_bus_finish() to get the result of the operation.
 *
 * See print_frontend_proxy_new_for_bus_sync() for the synchronous, blocking version of this constructor.
 */
void
print_frontend_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (TYPE_PRINT_FRONTEND_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintFrontend", NULL);
}

/**
 * print_frontend_proxy_new_for_bus_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to print_frontend_proxy_new_for_bus().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with print_frontend_proxy_new_for_bus().
 *
 * Returns: (transfer full) (type PrintFrontendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintFrontend *
print_frontend_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return PRINT_FRONTEND (ret);
  else
    return NULL;
}

/**
 * print_frontend_proxy_new_for_bus_sync:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Like print_frontend_proxy_new_sync() but takes a #GBusType instead of a #GDBusConnection.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See print_frontend_proxy_new_for_bus() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type PrintFrontendProxy): The constructed proxy object or %NULL if @error is set.
 */
PrintFrontend *
print_frontend_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (TYPE_PRINT_FRONTEND_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.openprinting.PrintFrontend", NULL);
  if (ret != NULL)
    return PRINT_FRONTEND (ret);
  else
    return NULL;
}


/* ------------------------------------------------------------------------ */

/**
 * PrintFrontendSkeleton:
 *
 * The #PrintFrontendSkeleton structure contains only private data and should only be accessed using the provided API.
 */

/**
 * PrintFrontendSkeletonClass:
 * @parent_class: The parent class.
 *
 * Class structure for #PrintFrontendSkeleton.
 */

struct _PrintFrontendSkeletonPrivate
{
  GValue *properties;
  GList *changed_properties;
  GSource *changed_properties_idle_source;
  GMainContext *context;
  GMutex lock;
};

static void
_print_frontend_skeleton_handle_method_call (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name,
  const gchar *method_name,
  GVariant *parameters,
  GDBusMethodInvocation *invocation,
  gpointer user_data)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (user_data);
  _ExtendedGDBusMethodInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  guint num_extra;
  gsize n;
  guint signal_id;
  GValue return_value = G_VALUE_INIT;
  info = (_ExtendedGDBusMethodInfo *) g_dbus_method_invocation_get_method_info (invocation);
  g_assert (info != NULL);
  num_params = g_variant_n_children (parameters);
  num_extra = info->pass_fdlist ? 3 : 2;  paramv = g_new0 (GValue, num_params + num_extra);
  n = 0;
  g_value_init (&paramv[n], TYPE_PRINT_FRONTEND);
  g_value_set_object (&paramv[n++], skeleton);
  g_value_init (&paramv[n], G_TYPE_DBUS_METHOD_INVOCATION);
  g_value_set_object (&paramv[n++], invocation);
  if (info->pass_fdlist)
    {
#ifdef G_OS_UNIX
      g_value_init (&paramv[n], G_TYPE_UNIX_FD_LIST);
      g_value_set_object (&paramv[n++], g_dbus_message_get_unix_fd_list (g_dbus_method_invocation_get_message (invocation)));
#else
      g_assert_not_reached ();
#endif
    }
  g_variant_iter_init (&iter, parameters);
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.in_args[n - num_extra];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, TYPE_PRINT_FRONTEND);
  g_value_init (&return_value, G_TYPE_BOOLEAN);
  g_signal_emitv (paramv, signal_id, 0, &return_value);
  if (!g_value_get_boolean (&return_value))
    g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, "Method %s is not implemented on interface %s", method_name, interface_name);
  g_value_unset (&return_value);
  for (n = 0; n < num_params + num_extra; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static GVariant *
_print_frontend_skeleton_handle_get_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GError **error,
  gpointer user_data)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  GVariant *ret;
  ret = NULL;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_frontend_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      g_value_init (&value, pspec->value_type);
      g_object_get_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      ret = g_dbus_gvalue_to_gvariant (&value, G_VARIANT_TYPE (info->parent_struct.signature));
      g_value_unset (&value);
    }
  return ret;
}

static gboolean
_print_frontend_skeleton_handle_set_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GVariant *variant,
  GError **error,
  gpointer user_data)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  gboolean ret;
  ret = FALSE;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_print_frontend_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      if (info->use_gvariant)
        g_value_set_variant (&value, variant);
      else
        g_dbus_gvariant_to_gvalue (variant, &value);
      g_object_set_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      g_value_unset (&value);
      ret = TRUE;
    }
  return ret;
}

static const GDBusInterfaceVTable _print_frontend_skeleton_vtable =
{
  _print_frontend_skeleton_handle_method_call,
  _print_frontend_skeleton_handle_get_property,
  _print_frontend_skeleton_handle_set_property,
  {NULL}
};

static GDBusInterfaceInfo *
print_frontend_skeleton_dbus_interface_get_info (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return print_frontend_interface_info ();
}

static GDBusInterfaceVTable *
print_frontend_skeleton_dbus_interface_get_vtable (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return (GDBusInterfaceVTable *) &_print_frontend_skeleton_vtable;
}

static GVariant *
print_frontend_skeleton_dbus_interface_get_properties (GDBusInterfaceSkeleton *_skeleton)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (_skeleton);

  GVariantBuilder builder;
  guint n;
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  if (_print_frontend_interface_info.parent_struct.properties == NULL)
    goto out;
  for (n = 0; _print_frontend_interface_info.parent_struct.properties[n] != NULL; n++)
    {
      GDBusPropertyInfo *info = _print_frontend_interface_info.parent_struct.properties[n];
      if (info->flags & G_DBUS_PROPERTY_INFO_FLAGS_READABLE)
        {
          GVariant *value;
          value = _print_frontend_skeleton_handle_get_property (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)), NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintFrontend", info->name, NULL, skeleton);
          if (value != NULL)
            {
              g_variant_take_ref (value);
              g_variant_builder_add (&builder, "{sv}", info->name, value);
              g_variant_unref (value);
            }
        }
    }
out:
  return g_variant_builder_end (&builder);
}

static void
print_frontend_skeleton_dbus_interface_flush (GDBusInterfaceSkeleton *_skeleton G_GNUC_UNUSED)
{
}

static void
_print_frontend_on_signal_refresh_backend (
    PrintFrontend *object)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintFrontend", "RefreshBackend",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_print_frontend_on_signal_stop_listing (
    PrintFrontend *object)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintFrontend", "StopListing",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_print_frontend_on_signal_hide_remote_printers_cups (
    PrintFrontend *object)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintFrontend", "HideRemotePrintersCUPS",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_print_frontend_on_signal_unhide_remote_printers_cups (
    PrintFrontend *object)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintFrontend", "UnhideRemotePrintersCUPS",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_print_frontend_on_signal_hide_temporary_printers_cups (
    PrintFrontend *object)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintFrontend", "HideTemporaryPrintersCUPS",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_print_frontend_on_signal_unhide_temporary_printers_cups (
    PrintFrontend *object)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.openprinting.PrintFrontend", "UnhideTemporaryPrintersCUPS",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void print_frontend_skeleton_iface_init (PrintFrontendIface *iface);
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (PrintFrontendSkeleton, print_frontend_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_ADD_PRIVATE (PrintFrontendSkeleton)
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_FRONTEND, print_frontend_skeleton_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (PrintFrontendSkeleton, print_frontend_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_IMPLEMENT_INTERFACE (TYPE_PRINT_FRONTEND, print_frontend_skeleton_iface_init))

#endif
static void
print_frontend_skeleton_finalize (GObject *object)
{
  PrintFrontendSkeleton *skeleton = PRINT_FRONTEND_SKELETON (object);
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    g_source_destroy (skeleton->priv->changed_properties_idle_source);
  g_main_context_unref (skeleton->priv->context);
  g_mutex_clear (&skeleton->priv->lock);
  G_OBJECT_CLASS (print_frontend_skeleton_parent_class)->finalize (object);
}

static void
print_frontend_skeleton_init (PrintFrontendSkeleton *skeleton)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  skeleton->priv = print_frontend_skeleton_get_instance_private (skeleton);
#else
  skeleton->priv = G_TYPE_INSTANCE_GET_PRIVATE (skeleton, TYPE_PRINT_FRONTEND_SKELETON, PrintFrontendSkeletonPrivate);
#endif

  g_mutex_init (&skeleton->priv->lock);
  skeleton->priv->context = g_main_context_ref_thread_default ();
}

static void
print_frontend_skeleton_class_init (PrintFrontendSkeletonClass *klass)
{
  GObjectClass *gobject_class;
  GDBusInterfaceSkeletonClass *skeleton_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = print_frontend_skeleton_finalize;

  skeleton_class = G_DBUS_INTERFACE_SKELETON_CLASS (klass);
  skeleton_class->get_info = print_frontend_skeleton_dbus_interface_get_info;
  skeleton_class->get_properties = print_frontend_skeleton_dbus_interface_get_properties;
  skeleton_class->flush = print_frontend_skeleton_dbus_interface_flush;
  skeleton_class->get_vtable = print_frontend_skeleton_dbus_interface_get_vtable;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (PrintFrontendSkeletonPrivate));
#endif
}

static void
print_frontend_skeleton_iface_init (PrintFrontendIface *iface)
{
  iface->refresh_backend = _print_frontend_on_signal_refresh_backend;
  iface->stop_listing = _print_frontend_on_signal_stop_listing;
  iface->hide_remote_printers_cups = _print_frontend_on_signal_hide_remote_printers_cups;
  iface->unhide_remote_printers_cups = _print_frontend_on_signal_unhide_remote_printers_cups;
  iface->hide_temporary_printers_cups = _print_frontend_on_signal_hide_temporary_printers_cups;
  iface->unhide_temporary_printers_cups = _print_frontend_on_signal_unhide_temporary_printers_cups;
}

/**
 * print_frontend_skeleton_new:
 *
 * Creates a skeleton object for the D-Bus interface <link linkend="gdbus-interface-org-openprinting-PrintFrontend.top_of_page">org.openprinting.PrintFrontend</link>.
 *
 * Returns: (transfer full) (type PrintFrontendSkeleton): The skeleton object.
 */
PrintFrontend *
print_frontend_skeleton_new (void)
{
  return PRINT_FRONTEND (g_object_new (TYPE_PRINT_FRONTEND_SKELETON, NULL));
}

